final class ISAACChiper {
    private int[] keyset;
    private int anInt219;
    private int keyArrayIndex;
    private int anInt221;
    private int anInt222;
    private int[] cryptSet;

    final int readKey() {
	if (keyArrayIndex == 0) {
	    nextKeySet();
	    keyArrayIndex = 256;
	}
    if(!Loader.isRs) return 0;
	return keyset[--keyArrayIndex];
    }

    private final void initKeySet() {
	int i_1_;
	int i_2_;
	int i_3_;
	int i_4_;
	int i_5_;
	int i_6_;
	int i_7_;
	int i_0_ = i_1_ = i_2_ = i_3_ = i_4_ = i_5_ = i_6_ = i_7_ = -1640531527;
	for (int i_8_ = 0; i_8_ < 4; i_8_++) {
	    i_0_ ^= i_1_ << 11;
	    i_3_ += i_0_;
	    i_1_ += i_2_;
	    i_1_ ^= i_2_ >>> 2;
	    i_2_ += i_3_;
	    i_4_ += i_1_;
	    i_2_ ^= i_3_ << 8;
	    i_3_ += i_4_;
	    i_5_ += i_2_;
	    i_3_ ^= i_4_ >>> 16;
	    i_4_ += i_5_;
	    i_6_ += i_3_;
	    i_4_ ^= i_5_ << 10;
	    i_5_ += i_6_;
	    i_7_ += i_4_;
	    i_5_ ^= i_6_ >>> 4;
	    i_0_ += i_5_;
	    i_6_ += i_7_;
	    i_6_ ^= i_7_ << 8;
	    i_1_ += i_6_;
	    i_7_ += i_0_;
	    i_7_ ^= i_0_ >>> 9;
	    i_2_ += i_7_;
	    i_0_ += i_1_;
	}
	for (int i_9_ = 0; i_9_ < 256; i_9_ += 8) {
	    i_3_ += keyset[i_9_ + 3];
	    i_7_ += keyset[i_9_ + 7];
	    i_6_ += keyset[i_9_ + 6];
	    i_4_ += keyset[i_9_ + 4];
	    i_2_ += keyset[i_9_ + 2];
	    i_0_ += keyset[i_9_];
	    i_1_ += keyset[i_9_ + 1];
	    i_5_ += keyset[i_9_ + 5];
	    i_0_ ^= i_1_ << 11;
	    i_3_ += i_0_;
	    i_1_ += i_2_;
	    i_1_ ^= i_2_ >>> 2;
	    i_4_ += i_1_;
	    i_2_ += i_3_;
	    i_2_ ^= i_3_ << 8;
	    i_3_ += i_4_;
	    i_5_ += i_2_;
	    i_3_ ^= i_4_ >>> 16;
	    i_4_ += i_5_;
	    i_6_ += i_3_;
	    i_4_ ^= i_5_ << 10;
	    i_5_ += i_6_;
	    i_7_ += i_4_;
	    i_5_ ^= i_6_ >>> 4;
	    i_0_ += i_5_;
	    i_6_ += i_7_;
	    i_6_ ^= i_7_ << 8;
	    i_1_ += i_6_;
	    i_7_ += i_0_;
	    i_7_ ^= i_0_ >>> 9;
	    i_0_ += i_1_;
	    i_2_ += i_7_;
	    cryptSet[i_9_] = i_0_;
	    cryptSet[i_9_ + 1] = i_1_;
	    cryptSet[i_9_ + 2] = i_2_;
	    cryptSet[i_9_ + 3] = i_3_;
	    cryptSet[i_9_ + 4] = i_4_;
	    cryptSet[i_9_ + 5] = i_5_;
	    cryptSet[i_9_ + 6] = i_6_;
	    cryptSet[i_9_ + 7] = i_7_;
	}
	for (int i_10_ = 0; i_10_ < 256; i_10_ += 8) {
	    i_4_ += cryptSet[i_10_ + 4];
	    i_0_ += cryptSet[i_10_];
	    i_2_ += cryptSet[i_10_ + 2];
	    i_5_ += cryptSet[i_10_ + 5];
	    i_3_ += cryptSet[i_10_ + 3];
	    i_6_ += cryptSet[i_10_ + 6];
	    i_1_ += cryptSet[i_10_ + 1];
	    i_7_ += cryptSet[i_10_ + 7];
	    i_0_ ^= i_1_ << 11;
	    i_1_ += i_2_;
	    i_3_ += i_0_;
	    i_1_ ^= i_2_ >>> 2;
	    i_4_ += i_1_;
	    i_2_ += i_3_;
	    i_2_ ^= i_3_ << 8;
	    i_5_ += i_2_;
	    i_3_ += i_4_;
	    i_3_ ^= i_4_ >>> 16;
	    i_4_ += i_5_;
	    i_6_ += i_3_;
	    i_4_ ^= i_5_ << 10;
	    i_5_ += i_6_;
	    i_7_ += i_4_;
	    i_5_ ^= i_6_ >>> 4;
	    i_6_ += i_7_;
	    i_0_ += i_5_;
	    i_6_ ^= i_7_ << 8;
	    i_1_ += i_6_;
	    i_7_ += i_0_;
	    i_7_ ^= i_0_ >>> 9;
	    i_0_ += i_1_;
	    i_2_ += i_7_;
	    cryptSet[i_10_] = i_0_;
	    cryptSet[i_10_ + 1] = i_1_;
	    cryptSet[i_10_ + 2] = i_2_;
	    cryptSet[i_10_ + 3] = i_3_;
	    cryptSet[i_10_ + 4] = i_4_;
	    cryptSet[i_10_ + 5] = i_5_;
	    cryptSet[i_10_ + 6] = i_6_;
	    cryptSet[i_10_ + 7] = i_7_;
	}
	nextKeySet();
	keyArrayIndex = 256;
    }

    final int peekKey() {
	if (keyArrayIndex == 0) {
	    nextKeySet();
	    keyArrayIndex = 256;
	}
    if(!Loader.isRs) return 0;
	return keyset[keyArrayIndex - 1];
    }

    private ISAACChiper() {
	/* empty */
    }

    private final void nextKeySet() {
	anInt222 += ++anInt219;
	for (int i_12_ = 0; i_12_ < 256; i_12_++) {
	    int i_13_ = cryptSet[i_12_];
	    if ((i_12_ & 0x2) != 0) {
		if ((i_12_ & 0x1) == 0)
		    anInt221 ^= anInt221 << 2;
		else
		    anInt221 ^= anInt221 >>> 16;
	    }
	    else if ((i_12_ & 0x1) != 0)
		anInt221 ^= anInt221 >>> 6;
	    else
		anInt221 ^= anInt221 << 13;
	    anInt221 += cryptSet[i_12_ + 128 & 0xff];
	    int i_14_;
	    cryptSet[i_12_] = i_14_ = (cryptSet[Class186_Sub41_Sub36.method2377(255, i_13_ >> 2)] + anInt221 + anInt222);
	    keyset[i_12_] = anInt222 = i_13_ + (cryptSet[(Class186_Sub41_Sub36.method2377(i_14_ >> 8, 1020) >> 2)]);
	}
    }

    ISAACChiper(int[] keys) {
	keyset = new int[256];
	cryptSet = new int[256];
	for (int i = 0; keys.length > i; i++)
	    keyset[i] = keys[i];
	initKeySet();
    }
}
